/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2003 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 2.02 of the PHP license,      |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/2_02.txt.                                 |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author:                                                              |
  +----------------------------------------------------------------------+

  $Id: header,v 1.10.8.1 2003/07/14 15:59:18 sniper Exp $ 
*/

#ifndef PHP_MCACHE_H
#define PHP_MCACHE_H

extern zend_module_entry mcache_module_entry;
#define phpext_mcache_ptr &mcache_module_entry

#ifdef PHP_WIN32
#define PHP_MCACHE_API __declspec(dllexport)
#else
#define PHP_MCACHE_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

PHP_MINIT_FUNCTION(mcache);
PHP_MSHUTDOWN_FUNCTION(mcache);
PHP_RINIT_FUNCTION(mcache);
PHP_RSHUTDOWN_FUNCTION(mcache);
PHP_MINFO_FUNCTION(mcache);

PHP_FUNCTION(memcache);
PHP_FUNCTION(pmemcache);
PHP_FUNCTION(is_initialized);
PHP_FUNCTION(set_initialized);
PHP_FUNCTION(add_server);
PHP_FUNCTION(get);
PHP_FUNCTION(set);
PHP_FUNCTION(add);
PHP_FUNCTION(replace);
PHP_FUNCTION(incr);
PHP_FUNCTION(decr);
PHP_FUNCTION(flush_all);
PHP_FUNCTION(delete);
PHP_FUNCTION(stats);

struct memcache_wrapper {
	struct memcache *mc;
	struct memcache_ctxt *ctxt;
	unsigned short int is_initialized;
	time_t expiration;
};

#define MC_SERIALIZED 1
#define MC_DOUBLE_VAL 2
#define MC_LONG_VAL 4 

/* 
  	Declare any global variables you may need between the BEGIN
	and END macros here:     
*/
ZEND_BEGIN_MODULE_GLOBALS(mcache)
	long  num_persistent;
ZEND_END_MODULE_GLOBALS(mcache)

/* In every utility function you add that needs to use variables 
   in php_mcache_globals, call TSRMLS_FETCH(); after declaring other 
   variables used by that function, or better yet, pass in TSRMLS_CC
   after the last function argument and declare your utility function
   with TSRMLS_DC after the last declared argument.  Always refer to
   the globals in your function as MCACHE_G(variable).  You are 
   encouraged to rename these macros something shorter, see
   examples in any other php module directory.
*/

#ifdef ZTS
#define MCACHE_G(v) TSRMG(mcache_globals_id, zend_mcache_globals *, v)
#else
#define MCACHE_G(v) (mcache_globals.v)
#endif

#endif	/* PHP_MCACHE_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * indent-tabs-mode: t
 * End:
 */
